<?php
/***************************************************************************
 *   Copyright (C) 2006-2007 by Konstantin V. Arkhipov                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 3 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/
/* $Id: DirectoryLocker.class.php 4687 2007-12-09 18:57:18Z voxus $ */

	/**
	 * Directories based locker.
	 * 
	 * @ingroup Lockers
	**/
	final class DirectoryLocker extends BaseLocker
	{
		private $directory = null;
		
		public function __construct($directory = 'dir-locking/')
		{
			$this->directory = ONPHP_TEMP_PATH.$directory;
			
			if (!is_writable($this->directory)) {
				if (!mkdir($this->directory, 0700, true)) {
					throw new WrongArgumentException(
						"can not write to '{$directory}'"
					);
				}
			}
		}
		
		public function get($key)
		{
			$mseconds = 0;
			
			while ($mseconds < 10000) {
				try {
					mkdir($this->directory.$key, 0700, false);
					return $this->pool[$key] = true;
				} catch (BaseException $e) {
					// still exist
					$mseconds += 200;
					usleep(200);
				}
			}
			
			return false;
		}
		
		public function free($key)
		{
			try {
				return rmdir($this->directory.$key);
			} catch (BaseException $e) {
				return false;
			}
		}
		
		public function drop($key)
		{
			return $this->free($key);
		}
	}
?>