<?php
/***************************************************************************
 *   Copyright (C) 2006-2007 by Konstantin V. Arkhipov                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 3 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/
/* $Id: IntegerType.class.php 4687 2007-12-09 18:57:18Z voxus $ */

	/**
	 * @ingroup Types
	**/
	class IntegerType extends BasePropertyType
	{
		/**
		 * @throws WrongArgumentException
		 * @return IntegerType
		**/
		public function setDefault($default)
		{
			Assert::isInteger(
				$default,
				"strange default value given - '{$default}'"
			);

			$this->default = $default;
			
			return $this;
		}
		
		public function getDeclaration()
		{
			if ($this->hasDefault())
				return $this->default;
			
			return 'null';
		}
		
		public function isMeasurable()
		{
			return false;
		}
		
		public function toColumnType()
		{
			return 'DataType::create(DataType::INTEGER)';
		}
		
		public function toPrimitive()
		{
			return 'Primitive::integer';
		}
		
		public function toPrimitiveLimits()
		{
			return
				'setMin(PrimitiveInteger::SIGNED_MIN)->'
				."\n"
				.'setMax(PrimitiveInteger::SIGNED_MAX)';
		}
		
		public function toXsdType()
		{
			return 'xsd:int';
		}
	}
?>